#
# We assume byte addressing
#
# Addresses are written in the following notation: n * 4 bytes
# This is done to make the code more legible.
#

# R0 and R1 are passed parameters
f:
 # Setup the stack frame
 move R7, FP             # Save the FP temporarily
 move FP, SP
 sub SP, SP, 24          # 6 32-bit words

 # Stack organisation (offset FP)
 # ==============================
 # 1 * 4: Old FP
 # 2 * 4: RA
 # 3 * 4: c[2]
 # 4 * 4: c[1]
 # 5 * 4: c[0]
 # 6 * 4: b

 # Store the RA, old FP and parameter b
 store FP - 1 * 4, R7    # Save the old frame pointer
 store FP - 2 * 4, RA    # Save RA
 store FP - 6 * 4, R1    # Save b

 move R0, 1               # e = 1

 # Setup the loop
 # We eliminate the [goto test_condition] here as,
 # the test depends on the value of e, and e is constant, non-equal to 0
 # and the test requires the e not to be equal to zero

loop_begin:
 move R0, FP - 5 * 4     # Setup the the first argument c
 move R1, FP - 6 * 4     # Setup the second argument &b
 call g

test_condition:
 if R0 != 0 goto loop_begin

 load R2, FP - 4 * 4   # Load c[1]
 load R3, FP - 6 * 4   # Load b
 add R0, R2, R3        # c[1] + b

 # Return
 load FP, FP - 1 * 4   # Restore the old FP
 load RA, FP - 2 * 4   # Restore the RA
 add SP, SP, 6 * 4     # Restore the old SP
 return
