# input is R0
# output is R0

# int f (int a){
#     if(a = 3){
#         for(int i =0; i < 10; i++){
#             int b = g(a);
#             if(b<10){
#                 break;
#             }
#             a = b;
#         }
#     }
#     return a;
# }
# 
# int b(int a);
 
f:
 
# Setup the stack frame
move R7, FP             # Save the FP temporarily
move FP, SP
sub SP, SP, 20          # 4 32-bit words

# Stack organisation (offset FP)
# ==============================
# 1 * 4: Old FP
# 2 * 4: RA
# 3 * 4: a
# 4 * 4: i
 
# Store the RA, old FP and parameter b
store FP - 1 * 4, R7    # Save the old frame pointer
store FP - 2 * 4, RA    # Save RA
store FP - 3 * 4, R0    # Save a
store FP - 4 * 4, 0     # Save i

if R0 != 3 goto LReturn # the if condition
goto Lcond              # the for loop starts here
Lbody:                  # the body of for loop
load R0, FP - 3 * 4     # load the value of a from memory and store it in R0
call g                  # the function call

# The return value of g(a) is stored in R0, so we use R0 instead of b
if R0 < 10 goto LReturn
store FP - 3 * 4, R0    # b = a


Lstep:                  # increment i
load R7, FP - 4 * 4     # load i
add R7, R7, 1           # i++
store FP - 4 * 4, R7    # store the updated i



Lcond:
load R7, FP - 4 * 4     # load i
if R7 < 10 goto Lbody   # the condition
 

LReturn:
load R0, FP - 3 * 4   # load into R0
# Epilogue
load FP, FP - 1 * 4   # Restore the old FP
load RA, FP - 2 * 4   # Restore the RA
add SP, SP, 4 * 4     # Restore the old SP
return

