# input is R0, R1
# output is R2

# int f (int a){
#     int b = 4;
#     if(a = 3){
#         for(int i =0; i < 10; i++){
#             b = g(a, b);
#             if(b<10){
#                 continue;
#             }
#             a = b;
#         }
#     }
#     return a;
# }
# 
# int b(int a);
 
f:
 
# Setup the stack frame
move R7, FP             # Save the FP temporarily
move FP, SP
sub SP, SP, 24          # 4 32-bit words

# Stack organisation (offset FP)
# ==============================
# 1 * 4: Old FP
# 2 * 4: RA
# 3 * 4: a
# 4 * 4: i
# 5 * 4: b
 
# Store the RA, old FP and parameter b
store FP - 1 * 4, R7    # Save the old frame pointer
store FP - 2 * 4, RA    # Save RA
store FP - 3 * 4, R0    # Save a
store FP - 4 * 4, 0     # Save i
store FP - 5 * 4, 4     # Save b

if R0 != 3 goto LReturn # the if condition
goto Lcond              # the for loop starts here
Lbody:                  # the body of for loop
load R0, FP - 3 * 4     # load the value of a from memory and store it in R0
load R1, FP - 5 * 4     # load the value of b from memory and store it in R1
call g                  # the function call

store FP - 5 * 4, R2    # store the return value of g in b

# The return value of g(a) is stored in R2, so we use R2 instead of b
if R2 < 10 goto Lstep
store FP - 3 * 4, R2    # b = a


Lstep:                  # increment i
load R7, FP - 4 * 4     # load i
add R7, R7, 1           # i++
store FP - 4 * 4, R7    # store the updated i



Lcond:
load R7, FP - 4 * 4     # load i
if R7 < 10 goto Lbody   # the condition
 

LReturn:
load R2, FP - 3 * 4   # load into R2
# Epilogue
load FP, FP - 1 * 4   # Restore the old FP
load RA, FP - 2 * 4   # Restore the RA
add SP, SP, 5 * 4     # Restore the old SP
return

